'****************************************************************
'*  Name    : TestK20_AmicusADC.BAS                             *
'*  Author  : [Alberto Freixanet]                               *
'*  Notice  : Copyright (c) 2016 [AFreixanet]                   *
'*          : All Rights Reserved                               *
'*  Date    : 05/02/2016                                        *
'*  Version : 1.0                                               *
'*  Notes   : Testing the Amicus_ADC.inc                        *
'*          :                                                   *
'**************************************************************** 

'    Include "D:/MyIncFiles/Amicus18_25K20.inc"
    Include "Amicus18_25K20.inc"
'-------------------------------------------------------------------------------
'    Include "Amicus18_ADC.inc"

'    Include "D:/MyIncFiles/Amicus_ADC.inc"
    Include "Amicus_ADC.inc"
'-------------------------------------------------------------------------------
    Dim ADC_Ready As Byte
    Dim ADC_Result As Word
    Dim ADC_ResultByte As Byte
    Dim ADC_ResultBit As Bit       
    Dim Result2 As Dword
    
MAIN_ADC:
' The program starts here
    DelayMS 100

    HRSOut "TEST ADC with "
    $if (_device = _18F23K20)
    HRSOut "PIC18F23K20"
    $endif
    $if (_device = _18F24K20)
    HRSOut "PIC18F24K20"
    $endif
    $if (_device = _18F25K20)
    HRSOut "PIC18F25K20"
    $endif
    $if (_device = _18F26K20)
    HRSOut "PIC18F26K20"
    $endif
    $if (_device = _18F23K22)
    HRSOut "PIC18F23K22"
    $endif
    $if (_device = _18F24K22)
    HRSOut "PIC18F24K22"
    $endif
    $if (_device = _18F25K22)
    HRSOut "PIC18F25K22"
    $endif
    $if (_device = _18F26K22)
    HRSOut "PIC18F26K22"
    $endif    
    HRSOut CR, CR
    
    ADC_IntDisable()       ' Disable the ADin interrupt

    ' PortConfig (ANSELX) Put the pins to analog.
    ' ADC_0ANA   ' All digital
    ' ADC_1ANA   ' analogue: AN0
    ' ADC_2ANA   ' analogue: AN0 to AN1
    ' ADC_3ANA   ' analogue: AN0 to AN2
    ' ADC_4ANA   ' analogue: AN0 to AN3
    ' ADC_5ANA   ' analogue: AN0 to AN4

    ' Put full PORT to analog
    ' ADC_PORTA_ANA  ' analogue: PORTA
    ' ADC_PORTB_ANA  ' analogue: PORTB
    ' ADC_PORTC_ANA  ' analogue: PORTC


    ' Open the Analogue to Digital Converter
'    OpenADC(ADC_FOSC_32 & ADC_RIGHT_JUST & ADC_20_TAD, ADC_CH0, ADC_REF_VDD_VSS, ADC_4ANA)
'    OpenADC(ADC_FOSC_32 & ADC_RIGHT_JUST & ADC_20_TAD, ADC_CH8, ADC_REF_VDD_VSS, ADC_12ANA)

'    OpenADC(ADC_FOSC_32 & ADC_RIGHT_JUST & ADC_20_TAD, ADC_CH0, ADC_REF_VDD_VSS, ADC_0ANA)
'    OpenADC(ADC_FOSC_32 & ADC_RIGHT_JUST & ADC_20_TAD, ADC_CH0, ADC_REF_VDD_VSS, ADC_1ANA)
'    OpenADC(ADC_FOSC_32 & ADC_RIGHT_JUST & ADC_20_TAD, ADC_CH0, ADC_REF_VDD_VSS, ADC_2ANA)
'    OpenADC(ADC_FOSC_32 & ADC_RIGHT_JUST & ADC_20_TAD, ADC_CH0, ADC_REF_VDD_VSS, ADC_3ANA)
'    OpenADC(ADC_FOSC_32 & ADC_RIGHT_JUST & ADC_20_TAD, ADC_CH0, ADC_REF_VDD_VSS, ADC_4ANA)
'    OpenADC(ADC_FOSC_32 & ADC_RIGHT_JUST & ADC_20_TAD, ADC_CH0, ADC_REF_VDD_VSS, ADC_8ANA)
'    OpenADC(ADC_FOSC_32 & ADC_RIGHT_JUST & ADC_20_TAD, ADC_CH0, ADC_REF_VDD_VSS, ADC_9ANA)
'    OpenADC(ADC_FOSC_32 & ADC_RIGHT_JUST & ADC_20_TAD, ADC_CH0, ADC_REF_VDD_VSS, ADC_10ANA)
'    OpenADC(ADC_FOSC_32 & ADC_RIGHT_JUST & ADC_20_TAD, ADC_CH0, ADC_REF_VDD_VSS, ADC_11ANA)
    OpenADC(ADC_FOSC_32 & ADC_RIGHT_JUST & ADC_20_TAD, ADC_CH0, ADC_REF_VDD_VSS, ADC_12ANA)

'    OpenADC(ADC_FOSC_32 & ADC_RIGHT_JUST & ADC_20_TAD, ADC_CH0, ADC_REF_VDD_VSS, ADC_0ANA_ONLY)
'    OpenADC(ADC_FOSC_32 & ADC_RIGHT_JUST & ADC_20_TAD, ADC_CH1, ADC_REF_VDD_VSS, ADC_1ANA_ONLY)
'    OpenADC(ADC_FOSC_32 & ADC_RIGHT_JUST & ADC_20_TAD, ADC_CH2, ADC_REF_VDD_VSS, ADC_2ANA_ONLY)
'    OpenADC(ADC_FOSC_32 & ADC_RIGHT_JUST & ADC_20_TAD, ADC_CH3, ADC_REF_VDD_VSS, ADC_3ANA_ONLY)
'    OpenADC(ADC_FOSC_32 & ADC_RIGHT_JUST & ADC_20_TAD, ADC_CH4, ADC_REF_VDD_VSS, ADC_4ANA_ONLY)
'    OpenADC(ADC_FOSC_32 & ADC_RIGHT_JUST & ADC_20_TAD, ADC_CH8, ADC_REF_VDD_VSS, ADC_8ANA_ONLY)
'    OpenADC(ADC_FOSC_32 & ADC_RIGHT_JUST & ADC_20_TAD, ADC_CH9, ADC_REF_VDD_VSS, ADC_9ANA_ONLY)
'    OpenADC(ADC_FOSC_32 & ADC_RIGHT_JUST & ADC_20_TAD, ADC_CH10, ADC_REF_VDD_VSS, ADC_10ANA_ONLY)
'    OpenADC(ADC_FOSC_32 & ADC_RIGHT_JUST & ADC_20_TAD, ADC_CH11, ADC_REF_VDD_VSS, ADC_11ANA_ONLY)
'    OpenADC(ADC_FOSC_32 & ADC_RIGHT_JUST & ADC_20_TAD, ADC_CH12, ADC_REF_VDD_VSS, ADC_12ANA_ONLY)
    
'    OpenADC(ADC_FOSC_32 & ADC_RIGHT_JUST & ADC_20_TAD, ADC_CH0 , ADC_REF_VDD_VSS, ADC_PORTA_ANA)
'    OpenADC(ADC_FOSC_32 & ADC_RIGHT_JUST & ADC_20_TAD, ADC_CH8 , ADC_REF_VDD_VSS, ADC_PORTB_ANA)

    While 1 = 1                                    
        'ADC_Result = ReadADC()                  ' Read result ADC channel
        'ADC_Result = ReadADC(ADC_CH1)          ' Read result ADC channel
        'Result2 = ADC_Result * 5000 / 1023      ' Scale it to volts using the Return_Var macro.

        ReadADC(ADC_CH0)                        ' Read result ADC channel
        Result2 = ADC_ResultW * 5000 / 1023     ' Scale it to volts using directly the ADC_ResultW.

        ADC_Result = Result2 / 1000
        HRSOut "ADC00: ", Dec ADC_Result, "."
        ADC_Result = Result2 // 1000
        HRSOut Dec3 ADC_Result, " Volts ", 13        
        '-----------------------------------------------------------------------
        ADC_Result = ReadADC(ADC_CH1)           ' Read result ADC channel

        Result2 = ADC_Result * 5000 / 1023      ' Scale it to volts
        ADC_Result = Result2 / 1000
        HRSOut "ADC01: ", Dec ADC_Result, "."
        ADC_Result = Result2 // 1000
        HRSOut Dec3 ADC_Result, " Volts ", 13
        '-----------------------------------------------------------------------
        ADC_Result = ReadADC(ADC_CH2)           ' Read result ADC channel

        Result2 = ADC_Result * 5000 / 1023      ' Scale it to volts
        ADC_Result = Result2 / 1000
        HRSOut "ADC02: ", Dec ADC_Result, "."
        ADC_Result = Result2 // 1000
        HRSOut Dec3 ADC_Result, " Volts ", 13 
        '-----------------------------------------------------------------------
        ADC_Result = ReadADC(ADC_CH3)           ' Read result ADC channel

        Result2 = ADC_Result * 5000 / 1023      ' Scale it to volts
        ADC_Result = Result2 / 1000
        HRSOut "ADC03: ", Dec ADC_Result, "."
        ADC_Result = Result2 // 1000
        HRSOut Dec3 ADC_Result, " Volts ", 13 
        '-----------------------------------------------------------------------
        ADC_Result = ReadADC(ADC_CH4)            ' Read result ADC channel

        Result2 = ADC_Result * 5000 / 1023       ' Scale it to volts
        ADC_Result = Result2 / 1000
        HRSOut "ADC04: ", Dec ADC_Result, "."
        ADC_Result = Result2 // 1000
        HRSOut Dec3 ADC_Result, " Volts ", 13 
        '-----------------------------------------------------------------------
        ADC_Result = ReadADC(ADC_CH8)            ' Read result ADC channel

        Result2 = ADC_Result * 5000 / 1023       ' Scale it to volts
        ADC_Result = Result2 / 1000
        HRSOut "ADC08: ", Dec ADC_Result, "."
        ADC_Result = Result2 // 1000
        HRSOut Dec3 ADC_Result, " Volts ", 13 
        '-----------------------------------------------------------------------
        ADC_Result = ReadADC(ADC_CH9)            ' Read result ADC channel

        Result2 = ADC_Result * 5000 / 1023       ' Scale it to volts
        ADC_Result = Result2 / 1000
        HRSOut "ADC09: ", Dec ADC_Result, "."
        ADC_Result = Result2 // 1000
        HRSOut Dec3 ADC_Result, " Volts ", 13 
        '-----------------------------------------------------------------------
        ADC_Result = ReadADC(ADC_CH10)            ' Read result ADC channel

        Result2 = ADC_Result * 5000 / 1023       ' Scale it to volts
        ADC_Result = Result2 / 1000
        HRSOut "ADC10: ", Dec ADC_Result, "."
        ADC_Result = Result2 // 1000
        HRSOut Dec3 ADC_Result, " Volts ", 13 
        '-----------------------------------------------------------------------
        ADC_Result = ReadADC(ADC_CH11)            ' Read result ADC channel

        Result2 = ADC_Result * 5000 / 1023       ' Scale it to volts
        ADC_Result = Result2 / 1000
        HRSOut "ADC11: ", Dec ADC_Result, "."
        ADC_Result = Result2 // 1000
        HRSOut Dec3 ADC_Result, " Volts ", 13 
        '-----------------------------------------------------------------------
        SetChanADC(ADC_CH12)            ' Select the channel
        StartConvADC()                  ' Start ADC conversion
        Repeat
            ADC_Ready = BusyADC()       ' Check if ADC running?
        Until ADC_Ready = 0
        'ADC_Result = MoveADCResult()

        Result2 = ADC_ResultW * 5000 / 1023      ' Scale it to volts using directly the ADC_ResultW.
        ADC_Result = Result2 / 1000
        HRSOut "ADC12: ", Dec ADC_Result, "."
        ADC_Result = Result2 // 1000
        HRSOut Dec3 ADC_Result, " Volts ", 13 
        '-----------------------------------------------------------------------
        HRSOut 13
        DelayMS 3000
    Wend
'-------------------------------------------------------------------------------

